"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
// Replace the custom Babel transform in react-scripts with the one from this
// package. We do this to force the use of a preset with TypeScript support.
var replaceBabelTransform = function (settingValue) {
    return /babelTransform\.js/.test(settingValue)
        ? path_1.default.resolve(__dirname, "rewireBabelTransform.js")
        : settingValue;
};
var rewireJest = function (config) {
    var settingKeys = Object.keys(config);
    var _loop_1 = function (i) {
        var setting = config[settingKeys[i]];
        if (Array.isArray(setting)) {
            // Replace file extensions in setting arrays.
            for (var j = 0; j < setting.length; j += 1) {
                setting[j] = setting[j].replace("js,jsx,mjs", "ts,tsx,js,jsx,mjs");
                setting[j] = setting[j].replace("js|jsx|mjs", "ts|tsx|js|jsx|mjs");
            }
        }
        else if (typeof setting === "object") {
            // Replace file extensions in keys of setting dictionaries.
            var settingObj_1 = {};
            Object.keys(setting).forEach(function (settingObjKey) {
                var newSettingsObjKey = settingObjKey.replace("js|jsx|mjs", "ts|tsx|js|jsx|mjs");
                var newSettingValue = replaceBabelTransform(setting[settingObjKey]);
                // @ts-ignore
                settingObj_1[newSettingsObjKey] = newSettingValue;
            });
            config[settingKeys[i]] = settingObj_1;
        }
    };
    /* tslint:disable-next-line */
    for (var i = 0; i < settingKeys.length; i += 1) {
        _loop_1(i);
    }
    config.moduleFileExtensions.push("ts", "tsx", "web.ts");
    return config;
};
exports.default = rewireJest;
